#include <stdlib.h>
#include <stdio.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include "avr_utils.h"
#include "lcd.h"
#include "key.h"
#include "menu.h"

unsigned char radio_ee EEMEM = 1;
unsigned char check_ee EEMEM = 1;
int val_ee EEMEM = 50;
int val1_ee EEMEM = 50;
char val2_ee[11] EEMEM = "abcdefg";
int val_tmp;

// forward-declaration of Submenu
extern Menu_page SubMenu1;

// definition of all textblocks for menu
char Text1[] PROGMEM = "Open File"; 
char Text2[] PROGMEM = "Main Menu"; 
char Text3[] PROGMEM = "This is a footer"; 
char Text4[] PROGMEM = "Settings"; 
char Text5[] PROGMEM = "Check_1"; 
char Text6[] PROGMEM = "Check_2"; 

char Text9[] PROGMEM = "Radio_1"; 
char Text10[] PROGMEM = "Radio_2"; 
char Text11[] PROGMEM = "Radio_3"; 
char Text12[] PROGMEM = "Radio_4"; 

// functions for actions
int aaaa=0;

void fu1(void)
{
	char_pos=0;
	lcd_int(aaaa++);
}

// definition of all elements (rect filled rect and so on)

Menu_button M_But1 PROGMEM = { MENU_BUTTON_DL, 5, 17, fu1, Text1 };
Menu_mbutton M_But2 PROGMEM = { MENU_MBUTTON_DL, 20, 17, NULL, &SubMenu1, Text2};
Menu_mbutton M_But3 PROGMEM = { MENU_MBUTTON_DL, 20, 17, NULL, &MainMenu, Text3};

Menu_rect Mpart1 PROGMEM = {MENU_RECT, 1, 6, 5, 5, NULL};
Menu_rect Mpart2 PROGMEM = {MENU_RECT_DL, 8, 6, 5, 5, NULL};
Menu_rect Mpart3 PROGMEM = {MENU_RECT_FILL, 15, 6, 5, 5, NULL};
Menu_rect Mpart4 PROGMEM = {MENU_RECT_FILL_DL, 22, 6, 5, 5, NULL};
Menu_rect Mpart5 PROGMEM = {MENU_RECT_BLOCK, 29, 6, 5, 5, NULL};
Menu_text Mpart6 PROGMEM = {MENU_TEXT, 10, 0, menu_keypad_test, Text4};
Menu_radio Mpart10 PROGMEM = {MENU_CHECK, 2, 1, NULL, (char *)&check_ee, {Text5,Text6,NULL}};
Menu_radio Mpart11 PROGMEM = {MENU_RADIO, 25, 0, NULL, (char *)&radio_ee, {Text9,Text10,Text11,Text12,NULL}};
Menu_slide Mpart12 PROGMEM = {MENU_SLIDE, 2, 3, 20,-1000,1000,&val_ee,&val_tmp,NULL};
Menu_val Mpart13 PROGMEM = {MENU_VAL, 2, 3, &val1_ee,NULL};
Menu_string Mpart14 PROGMEM = {MENU_STRING, 2, 6, sizeof(val2_ee)-1,(char *) &val2_ee,NULL};


// define all menupages
Menu_page SubMenu1 PROGMEM =
{
	NULL,
	{
		(m_ptr *)&M_But1,
		(m_ptr *)&M_But3,
		(m_ptr *)&Mpart13,
		(m_ptr *)&Mpart14,
		NULL
	}
};

Menu_page MainMenu PROGMEM =
{
	(Menu_page *) &SubMenu1,
	{
		(m_ptr *)&M_But1,
		(m_ptr *)&M_But2,
		(m_ptr *)&Mpart1,
		(m_ptr *)&Mpart2,
		(m_ptr *)&Mpart3,
		(m_ptr *)&Mpart4,
		(m_ptr *)&Mpart5,
		(m_ptr *)&Mpart6,
		(m_ptr *)&Mpart10,
		(m_ptr *)&Mpart11,
		(m_ptr *)&Mpart12,
		NULL
	}
};


